/*
 * QuickTime for Java SDK Sample Code

   Usage subject to restrictions in SDK License Agreement
 * Copyright:  1996-1999 Apple Computer, Inc.

 */
package ds.actions;

import quicktime.qd.*;
import quicktime.*;
import quicktime.std.image.Matrix;
import quicktime.app.image.Transformable;
import quicktime.app.event.*;
import quicktime.app.display.*;
/**
 * A class that provides the implementation of where an object will be scaled.
 */
public class Scaler extends quicktime.app.actions.TransformMatrix {
//____________________________ CLASS METHODS
	/**
	 * Create a Dragger object
	 * @param modifierKeyMask - if specified will determine which modifier keys must
	 * be depressed for the action to be invoked. The modifierTestConditions is set
	 * in this case to MouseResonder.kModifiersExactMatch
	 */
	public Scaler (int scaleFactor) {
		this.scaleFactor = scaleFactor;
	}

	private int scaleFactor;
		
//____________________________ INSTANCE METHODS					
	/**
	* The matrix handed in is the matrix of the transformable when it was first dragged
	*/
	protected void doTransformation (Matrix theMatrix, int deltaX, int deltaY) throws QTException {
		float x = deltaX / (float)scaleFactor;
		float y = deltaY / (float)scaleFactor;
		theMatrix.setSx (theMatrix.getSx() + x);
		theMatrix.setSy (theMatrix.getSy() + y);
	}
	
	/**
	 * This matrix is the current matrix of the transformable
	 */
	protected void doTransformation (Matrix theMatrix) throws QTException {
		float x = 1F / scaleFactor;
		float y = 1F / scaleFactor;
		theMatrix.setSx (theMatrix.getSx() + x);
		theMatrix.setSy (theMatrix.getSy() + y);
	}
}