/*
 * QuickTime for Java SDK Sample Code

   Usage subject to restrictions in SDK License Agreement
 * Copyright:  1996-1999 Apple Computer, Inc.

 */
package ds.actions;

import quicktime.qd.*;
import quicktime.*;
import quicktime.std.image.Matrix;
import quicktime.app.image.Transformable;
import quicktime.app.event.*;
import quicktime.app.display.*;
/**
 * A class that provides the implementation of where an object will be scaled.
 */
public class Skewer extends quicktime.app.actions.TransformMatrix {
//____________________________ CLASS METHODS
	/**
	 * Create a Dragger object
	 * @param modifierKeyMask - if specified will determine which modifier keys must
	 * be depressed for the action to be invoked. The modifierTestConditions is set
	 * in this case to MouseResonder.kModifiersExactMatch
	 */
	public Skewer (int xSkewFactor, int ySkewFactor) {
		xSkew = xSkewFactor;
		ySkew = ySkewFactor;
	}	
	
//____________________________ INSTANCE VARIABLES
	private int xSkew, ySkew;
		
//____________________________ INSTANCE METHODS					
	/**
	* The matrix handed in is the matrix of the transformable when it was first dragged
	*/
	protected void doTransformation (Matrix theMatrix, int deltaX, int deltaY) throws QTException {
		// protect against a zero divide
		float skewX = (xSkew != 0 ? deltaX / (float)xSkew : 0);
		float skewY = (ySkew != 0 ? deltaY / (float)ySkew : 0);
		
		theMatrix.skew (skewX, skewY, theMatrix.getTx(), theMatrix.getTy());
	}
	
	/**
	 * This matrix is the current matrix of the transformable
	 */
	protected void doTransformation (Matrix theMatrix) throws QTException {
		// this is left as an exercise for the reader
		// it would be called as part of a MatrixAction 
		// and would entail provide a skew to a matrix over time
	}
}